Codeforces G. Bus Number(dfs排列)

题目描述:

Bus Number

time limit per test

1 second

memory limit per test

256 megabytes

input

standard input

output

standard output

This night wasn't easy on Vasya. His favorite team lost, and he didn't find himself victorious either — although he played perfectly, his teammates let him down every time. He had to win at least one more time, but the losestreak only grew longer and longer... It's no wonder he didn't get any sleep this night at all.

In the morning, Vasya was waiting the bus to the university on the bus stop. Vasya's thoughts were hazy and so he couldn't remember the right bus' number quite right and got onto the bus with the number n.

In the bus, Vasya thought that he could get the order of the digits in the number of the bus wrong. Futhermore, he could "see" some digits several times, but the digits he saw were definitely in the real number of the bus. For example, if Vasya saw the number 2028, it could mean that the real bus number could be 2028, 8022, 2820 or just 820. However, numbers 80, 22208, 52 definitely couldn't be the number of the bus. Also, real bus number couldn't start with the digit 0, this meaning that, for example, number 082 couldn't be the real bus number too.

Given n, determine the total number of possible bus number variants.

Input

The first line contains one integer n(1≤n≤1018) — the number of the bus that was seen by Vasya. It is guaranteed that this number does not start with 0

Output

Output a single integer — the amount of possible variants of the real bus number.

Examples

Input

Copy

97

Output

Copy

2

Input

Copy

2028

Output

Copy

13

Note

In the first sample, only variants 97 and 79 are possible.

In the second sample, the variants (in the increasing order) are the following: 208

,280 , 802, 820,2028, 2208, 2280,2802,2820, 8022, 8202,8220

思路:

题目的意思是各一个数,数字里面的每个数至少使用一次,求用这些数字最多可以组成多少个开头不为零的数。

刚开始一个直白的想法就是,肯定要统计每个数字出现的次数,然后呢?

开始计算样例:0228,假如每个数只是用一次,028,可以组成\(A_3^3-A_2^2=4\)种数字,前面是所有数的全排列,后面减去开头为零的排列。然后可以使用两次,,0228,可以组成\(\frac{A_4^4}{A_2^2}-\frac{A_3^3}{A_2^2}\)种,因为有重复计算,所以会除以重复数字的全排列。

关键在于,我怎么知道什么时候该那个数字使用几次?

这时候,神奇的dfs就登场啦!可以用dfs搜索枚举所有的选择可能,把每一种的可能结果加起来就是最后的答案。我们来看一看,最后计算需要那几样东西。首先需要用了几个数字组成整个数,还要记录使用过每种数字的次数以便计算重复量。于是我们可以拿一个数组[10]来记录数字的使用情况,在dfs的时候,\(1.\)对于在原数中出现次数大于等于一的数字至少选一次,直到选完,进行更深一层的dfs。\(2.\)对于没有在原数中出现的数字,直接进行下一轮dfs。直到用到数字9完后来到10,因为没有数字了就可以终止该层递归,依照上面的计算方法计算,返回。

最后,得到的就是所有选取情况下的数字的可能性了。

需要注意的是由于数很大,要开long long,我开始在dfs返回时不小心把返回类型设成了int,还有因为排列数的计算要用到阶乘,一共只有最多18位数,可以方便地先预处理出20位的阶乘存起来。

代码:

#include <iostream>
#include <string>
using namespace std;
string s;
int cnt[10];
int used[10];
long long fac[21];
long long cishu = 0;//这个参数是我想看看进行了几次递归,神奇的发现次数比想象中的少,不知道为什么
void generator()//阶乘预处理
{
    fac[0]=fac[1]=1;
    for(int i = 2;i<=20;i++)
    {
        fac[i] = (long long)i*fac[i-1];
    }
}
long long dfs(int x,int y)
{
    cishu++;//递归一次次数加一
    //cout << "x " << x << " y " << y << endl;
    if(x==10)
    {
        long long ans = 0;
        ans += fac[y];
        for(int i =  0;i<10;i++)
        {
            /*if(used[i])
            {
                cout << "i"  << i << "used " << used[i] << endl;
            }*/
            ans /= fac[used[i]];
        }
        long long zero = 0;//减去0开头的数的可能情况
        if(used[0])
        {
            int num = y-1;
            zero += fac[num];
            zero /= fac[used[0]-1];
            for(int i = 1;i<10;i++)
            {
                zero /= fac[used[i]];
            }
        }
        //cout << "ans " << ans << " zero " << zero << endl;
        return ans-zero;
    }
    long long ans = 0;
    for(int i = 1;i<=cnt[x];i++)
    {
        used[x] = i;
        ans += dfs(x+1,y+i);
    }
    if(cnt[x]==0)
    {
        ans += dfs(x+1,y);
    }
    return ans;
}
int main()
{
    generator();
    /*for(int i = 0;i<=20;i++)
    {
        cout << fac[i] << " ";
    }
    cout << endl;*/
    cin >> s;
    for(int i = 0;i<s.size();i++)
    {
        cnt[s[i]-'0']++;
    }
    //cout << "cnt " << endl;
    /*for(int i = 0;i<10;i++)
    {
        cout << cnt[i] << " ";
    }
    cout << endl;*/

    long long ans = dfs(0,0);
    cout << ans << endl;
    //cout << cishu << endl;
    return 0;
}

猜你喜欢

转载自www.cnblogs.com/zhanhonhao/p/11290403.html
今日推荐